
public class SpecialHeap {
	public static void main(String[] args) {
		int[] feld = {3, 5, 1, 2, 6, 7, 23, 12, 4, 9, 24, 15, 0, 19, 18};
		System.out.println("Ungeordnetes Feld:");
		for(int i : feld) {
			System.out.print(i + " ");
		}
		System.out.println();
		System.out.println();
		
		
		System.out.println("Konvertiert zu Heap:");
		haldenEigenschaftHerstellen(feld);
		System.out.println("Heap-Eigenschaft erfllt: " + checkHeap(feld));
		
		for(int i : feld) {
			System.out.print(i + " ");
		}
		System.out.println();
		System.out.println();
		
		
		System.out.println("Sortiert mit Heap-Sort:");
		haldenSortierung(feld);
		
		for(int i : feld) {
			System.out.print(i + " ");
		}
		System.out.println();
	}
	
	public static void versickern(int[] feld, int von, int bis) {
		int index = von;
		int maxChild = getMaxChild(feld, index, bis);
		
		while(maxChild != -1 && feld[index] < feld[maxChild]) {
			tausche(feld, index, maxChild);
			index = maxChild;
			maxChild = getMaxChild(feld, index, bis);
		}
	}
	
	public static void tausche(int[] feld, int a, int b) {
		int tmp = feld[a];
		feld[a] = feld[b];
		feld[b] = tmp;		
	}
	
	public static void haldenEigenschaftHerstellen(int[] feld) {
		for(int i = feld.length/2 - 1; i>= 0; i--) {
			versickern(feld, i, feld.length-1);
		}
	}
	
	public static void haldenSortierung(int[] feld) {
		haldenEigenschaftHerstellen(feld);
		
		for(int i = 0; i < feld.length; i++) {
			tausche(feld, 0, feld.length - 1 - i);
			versickern(feld, 0, feld.length - 2 - i);
		}
	}
	
	private static int getMaxChild(int[] feld, int index, int bis) {
		int leftChild = getLeftChild(index);
		int rightChild = getRightChild(index);
		
		if(leftChild > bis && rightChild > bis)
			return -1;
		
		if(leftChild > bis)
			return rightChild;
		
		if(rightChild > bis)
			return leftChild;
		
		if(feld[leftChild] > feld[rightChild]) {
			return leftChild;
		} else {
			return rightChild;
		}
	}
	
	private static int getLeftChild(int index) {
		return 2 * index + 1;
	}
	
	private static int getRightChild(int index) {
		return 2 * index + 2;
	}
	
	private static boolean checkHeap(int[] feld) {
		for(int i = 0; i < feld.length; i++) {
			int leftChild = getLeftChild(i);
			int rightChild = getRightChild(i);
			
			if(leftChild < feld.length && feld[leftChild] > feld[i])
				return false;
			
			if(rightChild < feld.length && feld[rightChild] > feld[i])
				return false;
		}
		
		return true;
	}
}
